using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using ChangeDataAvalonia.Models;
using Microsoft.EntityFrameworkCore;
using Microsoft.Extensions.Logging;
using ReactiveUI;

namespace ChangeDataAvalonia.ViewModels
{
	public class CursesPageViewModel : ReactiveObject
	{
        _43pKudryashov2Context Connection;
        private List<UserCurse> uc;
        public CursesPageViewModel(_43pKudryashov2Context Connection)
        {
            this.Connection = Connection;
            UC = Connection.UserCurses.Include(x => x.UserCursesLists).ThenInclude(x => x.IdTeacherNavigation).ToList();
        }
        public List<UserCurse> UC { get => uc; set => this.RaiseAndSetIfChanged(ref uc, value); }
        public List<string> SortName => new List<string>() { " ", " " };
        public List<string> SortHour => new List<string>() { " ", " " };
        string sortByName = " ";
        public string SortByName
        {
            get => sortByName;
            set
            {
                sortByName = value;
                Fix();
            }
        }
        string sortByHour = " ";
        public string SortByHour
        {
            get => sortByHour;
            set
            {
                sortByHour = value;
                Filter();
            }
        }
        public List<int> HourList
        {
            get
            {
                List<int> hours = new List<int>() {0 };
                hours.AddRange(Connection.UserCurses.Select(x => x.CurseTime).ToList());
                return hours;
            }
        }
        public int SelectTime
        {
            get => selectTime;
            set
            {
                selectTime = value;
                Filter();
            }
        }
        int selectTime = 0;
        string search;
        public string Search
        {
            get => search;
            set
            {
                search = value;
                Filter();
            }
        }
        void Fix()
        {
            UC = Connection.UserCurses.Include(x => x.UserCursesLists).ThenInclude(x => x.IdTeacherNavigation).ToList();
            switch (sortByName)
            {
                case " ":
                    UC.Sort((x, y) => x.CurseName.CompareTo(y.CurseName));
                    break;
                case " ":
                    UC.Sort((x, y) => x.CurseName.CompareTo(y.CurseName));
                    UC.Reverse();
                    break;

            }
        }
        void Filter()
        {
            UC = Connection.UserCurses.Include(x => x.UserCursesLists).ThenInclude(x => x.IdTeacherNavigation).ToList();

            switch (sortByHour)
            {
                case " ":
                    UC.Sort((x, y) => x.CurseTime.CompareTo(y.CurseTime));
                    break;
                case " ":
                    UC.Sort((x, y) => x.CurseTime.CompareTo(y.CurseTime));
                    UC.Reverse();
                    break;

            }
            
            if (selectTime != 0)
            {
                UC = UC.Where(x => x.CurseTime==selectTime).ToList();
            }
            if (!string.IsNullOrWhiteSpace(search))
            {
                UC = UC.Where(x=> x.CurseName.ToLower().Contains(search.ToLower()) || x.CurseTime.ToString().Contains(Search)).ToList();
            }
        }
    }
}