﻿using Avalonia.Controls;
using ChangeDataAvalonia.Models;
using ReactiveUI;
using System;
using System.Linq;

namespace ChangeDataAvalonia.ViewModels
{
    public class MainWindowViewModel : ViewModelBase
    {

        public static _43pKudryashov2Context Connection = new _43pKudryashov2Context();

        UserControl us = new AutorizePage();
        AutorizePageViewModel autorizePage = new AutorizePageViewModel();
        PersonalPageViewModel personalPage;
        CursesPageViewModel cursesPage;
        //При переходе на страницу с курсами по данным пользователя с ролью "Администратор" вылетает ошибка исключения значения null. Но если нажать "Продолжить" в Visual Studio, то в самом проекте страница переключится на нужную
        public UserControl UC { get=> us; set { this.RaiseAndSetIfChanged(ref us, value); } }
        public AutorizePageViewModel AutorizePage { get => autorizePage; set => autorizePage = value; }
        public PersonalPageViewModel PersonalPage { get => personalPage; set => personalPage = value; }
        public CursesPageViewModel CursesPage { get => cursesPage; set => cursesPage = value; }

        public void Autorize()
        {
            UserDatum? userDatum = Connection.UserData.FirstOrDefault(x => x.Login == AutorizePage.Login && x.Password == AutorizePage.Password);
            if (userDatum == null)
            {
                AutorizePage.Message = "Пользователь не найден!";
                return;
            }
            if(userDatum.IdUser == 1)
            {
                personalPage = new PersonalPageViewModel(Connection, userDatum.IdTeacher);
                UC = new PersonalPage();
            }
            else
            {
                cursesPage = new CursesPageViewModel(Connection);
                UC = new CursesPage();
            }   
        }
        
    }
}
