using System;
using System.Collections.Generic;
using System.Linq;
using System.Numerics;
using System.Text.RegularExpressions;
using Avalonia.Controls;
using ChangeDataAvalonia.Models;


using Microsoft.EntityFrameworkCore;
using ReactiveUI;
using static System.Runtime.InteropServices.JavaScript.JSType;

namespace ChangeDataAvalonia.ViewModels
{
    public class PersonalPageViewModel : ReactiveObject
	{
        _43pKudryashov2Context Connection;
		UserDatum? userDatum;
		bool isPasswordChange = false;
        Regex phone = new Regex("[8]{1}[9]{1}[0-9]{9}");
        DateTime date = DateTime.Now;

        public PersonalPageViewModel(_43pKudryashov2Context Connection, int? id)
		{
			this.Connection = Connection;
			UserDatum = Connection.UserData.Include(x => x.IdUserNavigation).Include(x => x.IdTeacherNavigation.IdGenderNavigation).FirstOrDefault(x => x.IdTeacher == id);
			AutorizeData.oldPassword = userDatum.Password;
		}

		public UserDatum? UserDatum { get => userDatum; set => userDatum = value;}
        public string Surname
        {
            get => UserDatum.IdTeacherNavigation.Surname;
            set => UserDatum.IdTeacherNavigation.Surname = value;
        }
        public string Name
        {
            get => UserDatum.IdTeacherNavigation.Name;
            set => UserDatum.IdTeacherNavigation.Name = value;
        }
        public string Softname
        {
            get => UserDatum.IdTeacherNavigation.Softname;
            set => UserDatum.IdTeacherNavigation.Softname = value;
        }

        public string DR
		{
			get => UserDatum.IdTeacherNavigation.Birthday.ToString();
            set
            {
                date = Convert.ToDateTime(value);
                UserDatum.IdTeacherNavigation.Birthday = DateOnly.FromDateTime(Convert.ToDateTime(value));
            }
		}
		public string Exp
		{
			get => (UserDatum.IdTeacherNavigation.Experience / 12).ToString();
            set 
            {
                AutorizeData.Exp = Convert.ToInt32(value) * 12;
                UserDatum.IdTeacherNavigation.Experience = AutorizeData.Exp;
            }
		}
		public string Phone
		{
			get
			{
				if(UserDatum.IdTeacherNavigation.Phone == "NULL")
				{
					return "";
				}
				else
				{
                    if(phone.IsMatch(UserDatum.IdTeacherNavigation.Phone) == false)
                    {
                        string[] rightphone = UserDatum.IdTeacherNavigation.Phone.Split(' ');
                        rightphone[0] = "8";
                        UserDatum.IdTeacherNavigation.Phone = rightphone[0] + rightphone[1] + rightphone[2] + rightphone[3] + rightphone[4];
                        return UserDatum.IdTeacherNavigation.Phone;
                    }
                    else
                    {
                        return UserDatum.IdTeacherNavigation.Phone;
                    }
				}
			}
			set => UserDatum.IdTeacherNavigation.Phone = value;
		}
        public string Login
        {
            get => UserDatum.Login;
            set => UserDatum.Login = value;
        }
        public string Mail { get => UserDatum.IdTeacherNavigation.EMail; set => UserDatum.IdTeacherNavigation.EMail = value; }
        public List<string> Genders => Connection.Genders.Select(x=>x.Gender1).ToList();

		public string SelectedGender
		{
			get => UserDatum.IdTeacherNavigation.IdGenderNavigation.Gender1;
			set => UserDatum.IdTeacherNavigation.IdGender = Connection.Genders.FirstOrDefault(x => x.Gender1 == value).IdGender;
		}
        public string Message { get => AutorizeData.message; set => this.RaiseAndSetIfChanged(ref AutorizeData.message, value); }  //      
        public string RepeatPassword { get => repeatPassword; set => repeatPassword = value; } // ,       
        public bool IsPasswordChange { get => isPasswordChange; set => this.RaiseAndSetIfChanged(ref isPasswordChange, value); } // ,   ,  (  )    

        string repeatPassword; //   

        Canvas can;
        public Canvas Can
        {
            get => can;
            set => this.RaiseAndSetIfChanged(ref can, value);
        }

        public void SaveData()
		{
            if (Surname == "")
            {
                Message = "  !";
            }
            else if (Name == "")
            {
                Message = "  !";
            }
            else if (SelectedGender == "")
            {
                Message = "  !";
            }
            else if (DateTime.Compare(DateTime.Now.Date.AddYears(-18), date.Date) < 0)
            {
                Message = "     18!";
            }
            else if (Exp == "")
            {
                Message = " !";
            }
            else if (Mail == "")
            {
                Message = "  !";
            }
            else if (Phone == "")
            {
                Message = "  !";
            }
            else if (Login == "")
            {
                Message = "  !";
            }
            else if (phone.IsMatch(Phone))
            {
                if (UserDatum.Password == null || UserDatum.Password == "")
                {
                    UserDatum.Password = AutorizeData.oldPassword;
                }
                if (IsPasswordChange == (UserDatum.Password == repeatPassword))
                {
                    Connection.SaveChanges();
                    Message = " ";
                }
                else
                {
                    Message = "  ";
                }
            }
            else
            {
                Message = "     89XXXXXXXXX!";
            }
        }
    }
}